package com.chelvc.framework.security.firewall;

import com.chelvc.framework.base.context.ApplicationContextHolder;
import com.chelvc.framework.common.exception.FrameworkException;
import lombok.extern.slf4j.Slf4j;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;

/**
 * 拦截动作实现
 *
 * @author Woody
 * @date 2025/3/14
 */
@Slf4j
@Component
public class InterceptAction implements Action {
    /**
     * 动作名称
     */
    public static final String NAME = "INTERCEPT";

    @Override
    public String getName() {
        return NAME;
    }

    @Override
    public void execute(String principal, Rule rule) {
        log.warn("Firewall rule triggered: {}, principal: {}, action: {}", rule.getId(), principal, this.getName());
        String message = ApplicationContextHolder.getMessage("Forbidden");
        throw new FrameworkException(HttpStatus.FORBIDDEN.name(), null, message);
    }
}
